#include <WiFi.h>

const char* ssid = "EECS_Labs";
const char* password = "";

WiFiServer server(80);

void setup() {
    Serial.begin(115200);                     // Initialize Serial Monitor for debugging
    Serial1.begin(9600, SERIAL_8N1, 44, 43);  // UART1: TX=GPIO 43, RX=GPIO 44

    WiFi.begin(ssid, password);               // Connect to Wi-Fi
    while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.println("Connecting to Wi-Fi........");
    }
    Serial.println("Connected to Wi-Fi");
    Serial.print("IP Address: ");
    Serial.println(WiFi.localIP());           // Print IP address to Serial Monitor

    server.begin();                           // Start the HTTP server
}

void loop() {
    WiFiClient client = server.available();   // Check for incoming clients
    if (client) {
        // Read and print the HTTP request
        String request = client.readStringUntil('\r');
        Serial.println("Received HTTP request:");
        Serial.println(request);             // Print the request to Serial Monitor
        client.flush();

        // Parse the request and respond with commands
        if (request.indexOf("/command?cmd=LEFT") != -1) {
            Serial1.println("LEFT");         // Send "LEFT" to Pico
            Serial.println("Turning Left");
        } else if (request.indexOf("/command?cmd=RIGHT") != -1) {
            Serial1.println("RIGHT");        // Send "RIGHT" to Pico
            Serial.println("Turning Right"); // Respond to the client
        } else if (request.indexOf("/command?cmd=BLINK") != -1) {
            Serial1.println("BLINK");        // Send "BLINK" to Pico
            Serial.println("Blinking");      // Respond to the client
        } else {
            Serial.println("Unknown command received!");
            Serial.println("Unknown command");
        }
        client.stop();
    }
}
